



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ELF文件解析（二）：ELF header详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ELF文件解析（二）：ELF header详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 10:41:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://www.cnblogs.com/jiqingwu/p/elf_format_research_01.html" rel="external nofollow noreferrer">上一篇</a>讲了ELF文件的总体布局，以及section和segment的概念。按照计划，今天继续讲 ELF header。</p>
<p>讲新的内容之前，先更正一个错误：上一篇中讲section header table中的条目和文件中的section是一一对应的，其实这么讲是不对的。一个section必定有一个section header来描述它，但一个section header不一定在文件中有对应的section，因为有的section是不占用文件字节的。segment也是这个道理。</p>
<p>这篇文章本来应该上周写的，但上周忙于突击考试，周末又自我放纵，看了两天《相声有新人》，所以今天赶紧补上。</p>
<h2>ELF header定义</h2>
<p>ELF header的定义可以在 <code>/usr/include/elf.h</code> 中找到。<code>Elf32_Ehdr</code>是32位 ELF header的结构体。<code>Elf64_Ehdr</code>是64位ELF header的结构体。</p>
<pre class="prettyprint linenums"><code>typedef struct<br />
{<br />
  unsigned char	e_ident[EI_NIDENT];	/* Magic number和其它信息 */<br />
  Elf32_Half	e_type;			/* Object file type */<br />
  Elf32_Half	e_machine;		/* Architecture */<br />
  Elf32_Word	e_version;		/* Object file version */<br />
  Elf32_Addr	e_entry;		/* Entry point virtual address */<br />
  Elf32_Off	e_phoff;		/* Program header table file offset */<br />
  Elf32_Off	e_shoff;		/* Section header table file offset */<br />
  Elf32_Word	e_flags;		/* Processor-specific flags */<br />
  Elf32_Half	e_ehsize;		/* ELF header size in bytes */<br />
  Elf32_Half	e_phentsize;		/* Program header table entry size */<br />
  Elf32_Half	e_phnum;		/* Program header table entry count */<br />
  Elf32_Half	e_shentsize;		/* Section header table entry size */<br />
  Elf32_Half	e_shnum;		/* Section header table entry count */<br />
  Elf32_Half	e_shstrndx;		/* Section header string table index */<br />
} Elf32_Ehdr;

typedef struct<br />
{<br />
  unsigned char	e_ident[EI_NIDENT];	/* Magic number and other info */<br />
  Elf64_Half	e_type;			/* Object file type */<br />
  Elf64_Half	e_machine;		/* Architecture */<br />
  Elf64_Word	e_version;		/* Object file version */<br />
  Elf64_Addr	e_entry;		/* Entry point virtual address */<br />
  Elf64_Off	e_phoff;		/* Program header table file offset */<br />
  Elf64_Off	e_shoff;		/* Section header table file offset */<br />
  Elf64_Word	e_flags;		/* Processor-specific flags */<br />
  Elf64_Half	e_ehsize;		/* ELF header size in bytes */<br />
  Elf64_Half	e_phentsize;		/* Program header table entry size */<br />
  Elf64_Half	e_phnum;		/* Program header table entry count */<br />
  Elf64_Half	e_shentsize;		/* Section header table entry size */<br />
  Elf64_Half	e_shnum;		/* Section header table entry count */<br />
  Elf64_Half	e_shstrndx;		/* Section header string table index */<br />
} Elf64_Ehdr;<br />
</code></pre>
<p>64位和32位只是个别字段长度不同，比如 <code>Elf64_Addr</code> 和 <code>Elf64_Off</code> 都是64位无符号整数。而<code>Elf32_Addr</code> 和 <code>Elf32_Off</code>是32位无符号整数。这导致ELF header的所占的字节数不同。32位的ELF header占52个字节，64位的ELF header占64个字节。</p>
<h2>ELF header详解</h2>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/417313/201810/417313-20181022201440705-1728299314.png"></p>
<ol><li><p><code>e_ident</code>占16个字节。前四个字节被称作ELF的Magic Number。后面的字节描述了ELF文件内容如何解码等信息。等一下详细讲。</p></li>
<li><p><code>e_type</code>，2字节，描述了ELF文件的类型。以下取值有意义：</p>
<pre class="prettyprint linenums"><code> ET_NONE, 0, No file type<br />
 ET_REL, 1, Relocatable file（可重定位文件，通常是文件名以.o结尾，目标文件）<br />
 ET_EXEC, 2, Executable file （可执行文件）<br />
 ET_DYN, 3, Shared object file （动态库文件，你用gcc编译出的二进制往往也属于这种类型，惊讶吗？）<br />
 ET_CORE, 4, Core file （core文件，是core dump生成的吧？）<br />
 ET_NUM, 5，表示已经定义了5种文件类型<br />
 ET_LOPROC, 0xff00, Processor-specific<br />
 ET_HIPROC, 0xffff, Processor-specific<br />
</code></pre>
<p>从<code>ET_LOPROC</code>到 <code>ET_HIPROC</code> 的值，包含特定于处理器的语义。</p></li>
<li><p><code>e_machine</code>，2字节。描述了文件面向的架构，可取值如下（因为文档较老，现在有更多取值，参见<code>/usr/include/elf.h</code>中的<code>EM_</code>开头的宏定义）：</p>
<pre class="prettyprint linenums"><code> EM_NONE, 0, No machine<br />
 EM_M32, 1, AT&amp;T WE 32100<br />
 EM_SPARC, 2, SPARC<br />
 EM_386, 3, Intel 80386<br />
 EM_68K, 4, Motorola 68000<br />
 EM_88K, 5, Motorola 88000<br />
 EM_860, 7, Intel 80860<br />
 EM_MIPS, 8, MIPS RS3000<br />
 ... ...<br />
</code></pre></li>
<li><p><code>e_version</code>，2字节，描述了ELF文件的版本号，合法取值如下：</p>
<pre class="prettyprint linenums"><code> EV_NONE, 0, Invalid version<br />
 EV_CURRENT, 1, Current version，通常都是这个取值。<br />
 EV_NUM, 2, 表示已经定义了2种版本号<br />
</code></pre></li>
<li><p><code>e_entry</code>，（32位4字节，64位8字节），执行入口点，如果文件没有入口点，这个域保持0。</p></li>
<li><p><code>e_phoff</code>, （32位4字节，64位8字节），<em>program header table</em>的offset，如果文件没有PH，这个值是0。</p></li>
<li><p><code>e_shoff</code>, （32位4字节，64位8字节）， <em>section header table</em> 的offset，如果文件没有SH，这个值是0。</p></li>
<li><p><code>e_flags</code>, 4字节，特定于处理器的标志，32位和64位Intel架构都没有定义标志，因此eflags的值是0。</p></li>
<li><p><code>e_ehsize</code>, 2字节，ELF header的大小，32位ELF是52字节，64位是64字节。</p></li>
<li><p><code>e_phentsize</code>，2字节。program header table中每个入口的大小。</p></li>
<li><p><code>e_phnum</code>, 2字节。如果文件没有program header table, e_phnum的值为0。<code>e_phentsize</code>乘以<code>e_phnum</code>就得到了整个program header table的大小。</p></li>
<li><p><code>e_shentsize</code>, 2字节，section header table中entry的大小，即每个section header占多少字节。</p></li>
<li><p><code>e_shnum</code>, 2字节，section header table中header的数目。如果文件没有section header table, e_shnum的值为0。<code>e_shentsize</code>乘以<code>e_shnum</code>，就得到了整个section header table的大小。</p></li>
<li><p><code>e_shstrndx</code>, 2字节。section header string table index. 包含了section header table中section name string table。如果没有section name string table, <code>e_shstrndx</code>的值是<code>SHN_UNDEF</code>.</p></li></ol>
<blockquote><p>注意：program header table一般译为程序头表，section header table 一般译为节头表，因为这样的翻译无助于理解，所以我倾向于不翻。</p></blockquote>
<h2>e_ident</h2>
<p>回过头来，我们仔细看看文件前16个字节，也是<code>e_ident</code>。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/417313/201810/417313-20181022201527605-1024038352.png"></p>
<p>如图，前4个字节是ELF的Magic Number，固定为<code>7f 45 4c 46</code>。<br /><br />
第5个字节指明ELF文件是32位还是64位的。<br /><br />
第6个字节指明了数据的编码方式，即我们通常说的little endian或是big endian。little endian我喜欢称作小头在前，低位字节在前，或者直接说低位字节在低位地址，比如<code>0x7f454c46</code>，存储顺序就是<code>46 4c 45 7f</code>。big endian就是大头在前，高位字节在前，直接说就是高位字节在低位地址，比如<code>0x7f454c46</code>，在文件中的存储顺序是<code>7f 45 4c 46</code>。<br /><br />
第7个字节指明了ELF header的版本号，目前值都是1。<br /><br />
第8-16个字节，都填充为0。</p>
<h2>readelf读取ELF header</h2>
<p>我们使用<code>readelf -h &lt;elffile&gt;</code>可以读取文件的ELF header信息。<br /><br />
比如我本地有执行文件<code>hello</code>，我执行<code>reaelf -h hello</code>，结果如下：</p>
<pre class="prettyprint linenums"><code>ELF Header:<br />
  Magic:   7f 45 4c 46 02 01 01 00 00 00 00 00 00 00 00 00<br />
  Class:                             ELF64<br />
  Data:                              2's complement, little endian<br />
  Version:                           1 (current)<br />
  OS/ABI:                            UNIX - System V<br />
  ABI Version:                       0<br />
  Type:                              DYN (Shared object file)<br />
  Machine:                           Advanced Micro Devices X86-64<br />
  Version:                           0x1<br />
  Entry point address:               0x1050<br />
  Start of program headers:          64 (bytes into file)<br />
  Start of section headers:          14768 (bytes into file)<br />
  Flags:                             0x0<br />
  Size of this header:               64 (bytes)<br />
  Size of program headers:           56 (bytes)<br />
  Number of program headers:         11<br />
  Size of section headers:           64 (bytes)<br />
  Number of section headers:         29<br />
  Section header string table index: 28<br />
</code></pre>
<p>这是我用gcc生成的执行文件，但注意它的Type是<code>DYN (Shared object file)</code>，这大概是因为，这个文件不能直接执行，是依赖于解释器和c库才能运行。真正的可执行文件是解释器，而<code>hello</code>相对于解释器来说也是个共享库文件。这是我的推断，需要后面深入学习后验证。</p>
<p>今天就讲到这了，这周结束前计划写本系列第三篇，关于目标文件内section的知识。</p>
<p>2018-10-22 Mon</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxknov8.html">Python中函数、类、模块和包的调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gl4n7q.html">linux shell 字符串操作（长度，查找，替换）详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1m6dj9.html">Mac显示和隐藏文件的命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejo308.html">WCF学习笔记之传输安全</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdr459.html">数据库 E-R模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z2gd09.html">windows搭建web服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpnpk7q.html">4&period;Git基础-查看提交历史</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj30x38.html">老是上不了 google scholar&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ew12q.html">java 将mysql中Blob类型转为字符串或数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy4zyxq.html">cxf方式实现webservice接口笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yjp2q.html">c&num; 后台处理获取的JSON 数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/90274o3q.html">2017-2018-2 20155224『网络对抗技术』Exp5：MSF基础应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2op208.html">js 数组的删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vl7n6q.html">php5&period;4 trait 理解与学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kempwq.html">android ndk opencv  jni 编译集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ggoj8.html">BZOJ 3676 【APIO2014】 回文串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvel5xo9.html">CSS实现文字两端对齐</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql145x09.html">MVC controller的Action获取HttpRequest</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko7zojq.html">&grave;ECS弹性计算服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndmwm28.html">【Python】错误、调试和测试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdx35j9.html">在property里面设置版本号可灵活引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2z5voq.html">英国电信反悔华为是唯一真正的5G供应商</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o356k8.html">Swagger2 配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wkevwq.html">Linux Install geoip</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj4w579.html">BZOJ 4009&colon; &lbrack;HNOI2015&rsqb;接水果</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e42d7x9.html">&lbrack;luogu1447&rsqb;&lbrack;bzoj2005&rsqb;&lbrack;NOI2010&rsqb;能量采集</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwez1d8.html">洛谷P4240 毒瘤之神的考验  【莫比乌斯反演 &plus; 分块打表】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj43n79.html">php多进程、IPC和事件驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rlw1j9.html">深入理解Adaboost算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj01ze9.html">Ubuntu无法进入Windows的NTFS分区</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
